#include "serialGLCD.h"
#include "usart.h"

void clearLCD() 
{   /* Clears the display, eraseBlock is probably faster if you dont need to erase the entire screen.
	 Example: lcd.clearLCD();
	 */  
	int i, j;
	
	USART0_init();
	
	for(i = 0; i < 81; i++) {
		for(j = 0; j < 64; j++) {
			togglePixel(i, j, 0);
		}
	}
}

void reverseColor() 
{	/* Reverses the "color" (black on white / white on black)
	 Example: lcd.reverseColor();
	 */
	USART0_transmit(0x7C);
	USART0_transmit(0x14);
}

void backLight(int x) 
{   /* Sets backlight duty cycle. 0-100, 0=off.
	 Example: lcd.backLight(50);
	 */
	USART0_transmit(0x7C);
	USART0_transmit(0x02);
	USART0_transmit(x);
}


void togglePixel(int x, int y, int z) 
{     /* Toggles a pixel. x and y for coord, z=1 sets, z=0 erases.
	   Example: lcd.togglePixel(30,30,1);
	   */
	   
	char a, b, c;
	
	a = (char)x;
	b = (char)y;
	c = (char)z;
	
	USART0_transmit(0x7C);
	USART0_transmit(0x10);
	
	if(x > 128) {
		USART0_transmit(0x80);
	}
	else if(x < 0) {
		USART0_transmit(0x00);
	}
	else {
		USART0_transmit(a);
	}
	if(y > 64) {
		USART0_transmit(0x40);
	}
	else if(y < 0) {
		USART0_transmit(0x00);
	}
	else {
		USART0_transmit(b);
	}
	if(z != 1 && z != 0) {
		USART0_transmit(1);
	}
	else {
		USART0_transmit(c);
	}
}
